/******************************************************************
error()ʤƥΤشؿ
******************************************************************/
#ident "$Id: error.c 901 2004-12-11 17:57:21Z mkoya $"

#if defined HAVE_CONFIG_H
#   include "config.h"
#endif

#include <stdio.h>
#if defined STDC_HEADERS
#   include <stdlib.h>
#   include <stdarg.h>
#   define VA_START(args, lastarg) va_start(args, lastarg)
#else
#   include <varargs.h>
#   define VA_START(args, lastarg) va_start(args)
#endif
#if defined HAVE_STRING_H
#   if !defined STDC_HEADERS && defined HAVE_MEMORY_H
#       include <memory.h>
#   endif
#   include <string.h>
#endif
#if defined HAVE_STRINGS_H
#    include <strings.h>
#endif

#include <error.h>

#if !HAVE_DECL_PROGRAM_INVOCATION_NAME
char *program_invocation_name, *program_invocation_short_name;

void set_program_invocation_name(char *arg)
{
    program_invocation_name = arg;

    arg = strrchr (arg, '/');
    if (arg)
	program_invocation_short_name = arg + 1;
    else
	program_invocation_short_name = program_invocation_name;
}
#endif

void (*error_print_progname)(void) = NULL;
int error_message_count = 0;

void error(int status, int errnum, const char *format, ...)
{
    va_list ap;

    if (error_print_progname) error_print_progname();
    else if (program_invocation_name)
	fprintf(stderr, "%s: ", program_invocation_name);

    if (errnum) fprintf(stderr, "%s: ", strerror(errnum));

    VA_START(ap, format);
    vfprintf(stderr, format, ap);
    va_end(ap);

    putc('\n', stderr);

    error_message_count++;
    if (status) exit(status);
}

void error_at_line(int status, int errnum, const char *fname,
		   unsigned int lineno, const char *format, ...)
{
    va_list ap;

    if (error_print_progname) error_print_progname();
    else if (program_invocation_name)
	fprintf(stderr, "%s:", program_invocation_name);
    if (fname)
	fprintf(stderr, "%s:", fname);
    fprintf(stderr, "%d: ", lineno);

    if (errnum) fprintf(stderr, "%s: ", strerror(errnum));

    VA_START(ap, format);
    vfprintf(stderr, format, ap);
    va_end(ap);

    putc('\n', stderr);

    error_message_count++;
    if (status) exit(status);
}

#if defined TEST
int main(int argc, char **argv)
{
    error(0, 0, "no exit");
    error(0, 2, "no exit");
    error_at_line(0, 2, "inputfile", 100, "no exit");
    fprintf(stderr, "error_message_count: %d\n", error_message_count);
    error(1, 0, "exit 1");
    return 0;
}
#endif
