/******************************************************************
memmoveʤƥΤشؿ
******************************************************************/
#ident "$Id: memmove.c 901 2004-12-11 17:57:21Z mkoya $"

#if defined HAVE_CONFIG_H
#   include "config.h"
#endif

#include <sys/types.h>

void *memcpy(void *dest, const void *src, size_t n);

static void *membackcpy(void *dest, const void *src, size_t n)
{
    char *ret = dest;

    dest += n-1;
    src  += n-1;

    while (n--) *(char *)dest-- = *(char *)src--;

    return ret;
}

void *memmove(void *dest, const void *src, size_t n)
{
    if (dest < src) return memcpy(dest, src, n);
    else            return membackcpy(dest, src, n);
}

/***************************************************************
ƥ
***************************************************************/
#if defined TEST
#include <stdio.h>

int main(void)
{
    char src[27] = "abcdefghijklmnopqrstuvwxyz";
    char dest[27];

    memmove(dest, src, sizeof(src));
    printf("%s\n", dest);
    memmove(dest, dest+5, 10);
    printf("%s\n", dest);
    printf("fghijklmnoklmnopqrstuvwxyz\n");

    memmove(dest, src, sizeof(src));
    printf("%s\n", dest);
    memmove(dest+5, dest, 10);
    printf("%s\n", dest);
    printf("abcdeabcdefghijpqrstuvwxyz\n");
    return 0;
}
#endif
